<?php

class Download {
	
	//---------------------------------------------------------
	//  コントロール設定
	//---------------------------------------------------------
	
	public static function control() {
		
		// コントロール設定を返す
		return array(true, true, false, false);
		
	}
	
	//---------------------------------------------------------
	//  ログダウンロード
	//---------------------------------------------------------
	
	public static function execute() {
		
		// DBクラスを取得
		$db = $GLOBALS['obj']['db'];
		
		// テーブル名を取得
		$table = $GLOBALS['args'][1];
		
		// CSVファイル名を設定
		$csv = $table . '.csv';
		
		// 引数を「_」で分割
		$values = explode('_', $table);
		
		// 月間テーブルの時
		if (count($values) >= 2) {
			
			// DB名を設定
			$atDB = 'access_' . $values[0] . '_' . $values[1] . '.db';
			
			// DBが存在しない時は終了
			if (!$db->exists($atDB)) {
				return;
			}
			
			// DBを追加接続
			$db->attach($atDB);
			
			// テーブル名を再設定
			$table = $values[2];
			
		}
		
		// クエリーを作成
		$query = "select * from $table;";
		
		// クエリーを実行
		$results = $db->query($query);
		
		// タイムアウト時間を60秒に設定
		//set_time_limit(60);
		
		// ダウンロード用ヘッダーを出力
		header('Content-Type: application/octet-stream');
		header('Content-Disposition: attachment; filename=' . $csv);
		
		// 詳細ログを表示するループ
		while ($rec = $db->fetch($results)) {
			
			// URL「,」を実体文字参照に変換
			if (isset($rec['url'])) {
				$rec['url'] = preg_replace('/,/', '&#44;', $rec['url']);
			}
			
			// ページタイトルを変換
			if (isset($rec['title'])) {
				$rec['title'] = preg_replace('/,/', '&#44;', $rec['title']);
			}
			
			// リンク元を変換
			if (isset($rec['referrer'])) {
				$rec['referrer'] = preg_replace('/,/', '&#44;', $rec['referrer']);
			}
			
			// UA「,」を「.」に変換
			if (isset($rec['ua'])) {
				$rec['ua'] = preg_replace('/,/', '.', $rec['ua']);
			}
			
			// UAフルを変換
			if (isset($rec['ua_full'])) {
				$rec['ua_full'] = preg_replace('/,/', '.', $rec['ua_full']);
			}
			
			// 「,」で区切って出力
			echo preg_replace("/[\r\n\f\t\a\e\b]/", '',implode(',', $rec)) . "\n";
			
		}
		
	}
	
}

