<?php

class Shortcut {
	
	//---------------------------------------------------------
	//  コントロール設定
	//---------------------------------------------------------
	
	public static function control() {
		
		// コントロール設定を返す
		return array(true, true, 'Header', 'Footer');
		
	}
	
	//---------------------------------------------------------
	//  ログ表示
	//---------------------------------------------------------
	
	public static function execute() {
		
		// DBクラスを取得
		$db = $GLOBALS['obj']['db'];
		
		// テンプレートクラスを取得
		$tmpl = $GLOBALS['obj']['tmpl'];
		
		// 表示種別（モード）を取得
		$type = $GLOBALS['args'][1];
		
		// パラメータ種別を取得
		$param = $GLOBALS['args'][2];
		
		// 指定年月日を取得
		$y = $GLOBALS['args']['y'];
		$m = $GLOBALS['args']['m'];
		
		////////////////////////////////////////////////////////////
		
		// テーブル名を取得
		$countTable = $db->table('count');
		
		// リンクを設定
		$link = '<a href="' . ROOT . '/' . $type . '/';
		
		// リンクを別名で保持
		$orgLink = $link;
		
		// 件数
		$count = 0;
		
		// SQL実行結果
		$results = null;
		
		////////////////////////////////////////////////////////////
		
		// 詳細 or 日別統計 の時
		if ($type === 'visit' || $type === 'param_daily') {
			
			// DB名を設定
			$atDB = 'access_' . $y . '_' . $m . '.db';
			
			// DBが存在する時
			if ($db->exists($atDB)) {
				
				// DBに追加接続
				$db->attach($atDB);
				
				// クエリーを作成
				$selectMaxQuery = "select max(sum_uu) as max_uu, max(sum_pv) as max_pv from $countTable;";
				
				// クエリーを実行
				$rec = $db->queryFetch($selectMaxQuery);
				
				// 総数の桁数を取得
				$uuFigure = strlen($rec['max_uu']);
				$pvFigure = strlen($rec['max_pv']);
				
				// クエリーを作成
				$selectCountQuery = "select count(date) as count from $countTable;";
				
				// クエリーを実行
				$count = $db->queryFetch($selectCountQuery, 'count');
				
				// クエリーを作成
				$query = "select date, sum_uu, sum_pv from $countTable order by date desc;";
				
				// クエリーを実行
				$results = $db->query($query);
				
			}
			
		}
		
		////////////////////////////////////////////////////////////
		
		// 詳細以外の時
		else {
			
			// DB一覧を取得
			$files = glob(DATA_DIR . "/access*.db");
			
			// 降順で配列をソート
			rsort($files);
			
			// 該当件数を取得
			$count = count($files);
			
		}
		
		////////////////////////////////////////////////////////////
		
		// パラメータ統計の時
		if ($type === 'param' || $type === 'pie_chart' || $type === 'transition') {
			
			// iniファイルのキーを設定
			$type = $param;
			
			// 検索語以外の時はリンクに追記
			if ($param !== 'search_word' && $param !== 'search_words') {
				$link .= $param . '/';
			}
			
		}
		
		////////////////////////////////////////////////////////////
		
		// テンプレートを分割
		list($head, $body, $foot) = $tmpl->read('shortcut.htm');
		
		// ヘッダーテンプレートを出力
		$tmpl->show($head);
		
		// テンプレート変数
		$vars = array();
		
		// 区切り文字
		$tab = "\n\t\t\t\t\t\t\t\t";
		
		// 詳細ログを表示するループ
		for ($i = 0; $i < $count; $i++) {
			
			// 詳細 or 日別統計 の時
			if ($type === 'visit' || $type === 'param_daily') {
				
				// データを取り出し
				$rec = $db->fetch($results);
				
				// 日付を分割
				list($y, $m, $d) = explode('-', $rec['date']);
				
				// 表示項目に日付を設定
				$vars['link'] = '<span>' . $y . '/' . $m . '/' . $d . '</span>';
				
				// ユニーク数 / PV数 を表示項目に追記
				$vars['link'] .= str_pad($rec['sum_uu'], $uuFigure, '0', STR_PAD_LEFT) . ' / ';
				$vars['link'] .= str_pad($rec['sum_pv'], $pvFigure, '0', STR_PAD_LEFT);
				
				// 年月データを整形
				$ym = $y . '/' . $m . '/' . $d . '/';
				
			}
			
			// 詳細以外の時
			else {
				
				// 検索DB名を設定
				$reg = 'access_' . $y . '_(\d{2})\.db';
				
				// 月間DBではない時は次へ
				if (!preg_match("/$reg/", $files[$i], $m)) {
					continue;
				}
				
				// 表示項目に日付を設定
				$vars['link'] = '<span>' . $y . '/' . $m[1] . '</span>';
				
				// 年月データを整形
				$ym = $y . '/' . $m[1] . '/';
				
			}
			
			// オプションデータが存在しない時はタイトルを配列に設定
			if (!isset($GLOBALS['menu'][$type])) {
				$GLOBALS['menu'][$type]['base'] = $GLOBALS['title'][$type];
			}
			
			// グラフ、日間パラメータの時
			if ($type === 'graph' || $type === 'param_daily') {
				
				// グラフの時は追記
				if ($type === 'graph') {
					$ym .= '01/';
				}
				
				// 表示項目に追記
				foreach ($GLOBALS['menu'][$type] as $key => $val) {
					$vars['link'] .= $tab . $link . $key . '/' . $ym . '">' . $val . '</a>';
				}
				
			}
			
			// グラフ以外の時
			else {
				
				// iniファイル読み込みループ
				foreach ($GLOBALS['menu'][$type] as $key => $val) {
					
					// 基本の時はkeyを空欄にする
					if ($key === 'base') {
						$opt = '';
					}
					
					// 検索語の時は変則対応
					elseif ($key === 'word' || $key === 'words') {
						$opt = '';
						$link = $orgLink . 'search_' . $key . '/';
					}
					
					// 上記以外の時
					else {
						$opt = $key . '/';
					}
					
					// 表示項目に追記
					$vars['link'] .= $tab . $link . $ym . $opt . '">' . $val . '</a>';
					
				}
				
			}
			
			// 色分け用class属性を設定
			$vars['tr'] = ($i % 2 === 0) ? 2 : 1;
			
			// メインテンプレートを出力
			$tmpl->show($body, $vars);
			
		}
		
		// フッターテンプレートを出力
		$tmpl->show($foot, $vars);
		
	}
	
}

