<?php

// iniオプションを設定（エラー関連）
ini_set('error_reporting', E_ALL);
ini_set('display_errors', 1);

// iniオプションを設定（ファイルオープン）
ini_set('allow_url_fopen', 1);

// プロトコル
$protocol = '';

// ポート番号
$port = 0;

// HTTP接続の時
if (!isset($_SERVER['HTTPS']) or $_SERVER['HTTPS'] === 'off') {
	
	// プロトコルを設定
	$protocol = 'http';
	
	// ポート番号を設定
	$port = 80;
	
}

// HTTPS接続の時
else {
	
	// プロトコルを設定
	$protocol = 'https';
	
	// ポート番号を設定
	$port = 443;
	
}

// ホスト名を取得
$host = $_SERVER['SERVER_NAME'];

// ドキュメントルートを取得
$root = preg_quote($_SERVER['DOCUMENT_ROOT'], '/');

// write.phpまでのパスを取得
$path = preg_replace("/$root/", '', __DIR__) . '/write.php';

// 引数を設定
$path .= '?url=' . $protocol . '://' . $host . $_SERVER['REQUEST_URI'];

// URLを設定
$url = $protocol . '://' . $host . $path;

// IPアドレス
$ip = '';

// IPアドレスを取得
if (isset($_SERVER['HTTP_CLIENT_IP'])) {
	$ip = $_SERVER['HTTP_CLIENT_IP'];
} elseif (isset($_SERVER['HTTP_X_FORWARDED_FOR'])) {
	$ip = $_SERVER['HTTP_X_FORWARDED_FOR'];
} else {
	$ip = $_SERVER['REMOTE_ADDR'];
}

// データ配列
$array = array();

// 基本情報を配列に追記
//$array[] = 'GET ' . $url . ' HTTP/1.1';
//$array[] = 'Host: ' . $host;
$array[] = 'From: ' . $ip;
$array[] = 'Connection: close';// HTTP/2で廃止

// 言語設定が存在する時は追記
if (isset($_SERVER['HTTP_ACCEPT_LANGUAGE'])) {
	$array[] = 'Accept-language: ' . $_SERVER['HTTP_ACCEPT_LANGUAGE'];
}

// UAが存在する時は追記
if (isset($_SERVER['HTTP_USER_AGENT'])) {
	$array[] = 'User-Agent: ' . $_SERVER['HTTP_USER_AGENT'];
}

// リンク元が存在する時は追記
if (isset($_SERVER['HTTP_REFERER'])) {
	$array[] = 'Referer: ' . $_SERVER['HTTP_REFERER'];
}

// COOKIEが存在する時は追記
if (isset($_SERVER['HTTP_COOKIE'])) {
	$array[] = 'Cookie: ' . $_SERVER['HTTP_COOKIE'];
}

// cURLハンドルを作成
$ch = curl_init();

// URLを設定
curl_setopt($ch, CURLOPT_URL, $url);

// レスポンスを変数で受け取る（設定しないと直接出力）
curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1);

// 証明書をチェックしない
curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, false);

// タイムアウトを設定
curl_setopt($ch, CURLOPT_TIMEOUT, 10);

// ヘッダーを設定
curl_setopt($ch, CURLOPT_HTTPHEADER, $array);

// リクエストを実行
curl_exec($ch);

// ハンドルを閉じる
curl_close($ch);

