<?php

class Encode {
	
	//---------------------------------------------------------
	//  Webエンコード
	//---------------------------------------------------------
	
	public function webEncode($str, $encoding = 'UTF-8') {
		
		// 文字コードが違う時は変換
		if (mb_detect_encoding($str) != $encoding) {
			$str = mb_convert_encoding($str, $encoding, 'ASCII, JIS, UTF-8, EUC-JP, SJIS');
		}
		
		// 参照文字列に変換
		$str = htmlspecialchars($str);
		
		// 参照文字列に変換（特殊文字）
		$str = preg_replace('/,/', '&#44;', $str);
		$str = preg_replace('/\r/', '', $str);
		$str = preg_replace('/\n/', '<br>', $str);
		
		// エンコードデータを返す
		return $str;
		
	}
	
	//---------------------------------------------------------
	//  Webデコード
	//---------------------------------------------------------
	
	public function webDecode($str) {
		
		// 参照文字列を変換
		$str = html_entity_decode($str);
		
		// 改行を変換
		$str = preg_replace('/<br>|<br \/>/', "\n", $str);
		
		// デコードデータを返す
		return $str;
	
	}
	
	//---------------------------------------------------------
	//  リンクエンコード
	//---------------------------------------------------------
	
	public function linkEncode($str) {
		
		// Aタグを削除
		$str = preg_replace('/&lt;a .+&gt;(.+)&lt;\/a&gt;/i', "$1", $str);
		
		// リンクを整形
		$str = preg_replace('/(https:\/\/[\w\.\/\-=&%?,;#]*)/', "<a href=\"$1\" target=\"_blank\">$1</a>", $str);
		
		// エンコードデータを返す
		return $str;
		
	}
	
	//---------------------------------------------------------
	//  リンクデコード
	//---------------------------------------------------------
	
	public function linkDecode($str) {
		
		// Aタグを削除
		$str = preg_replace('/(<a href="https:\/\/)(.+)(" target="_blank">)(https:\/\/)([^<>]+)(<\/a>)/', "$4$5", $str);
		
		// デコードデータを返す
		return $str;
		
	}
	
}

